/*****************************************************************************/
/*                      WiNRADiO G65DDC EXCALIBUR SIGMA                      */
/*                                SDK DEMO                                   */
/*                      Global variables and functions                       */
/*                        (c) Copyright RADIXON 2020                         */
/*****************************************************************************/

#include "u_global.h"

TGlobal Global;

void TGlobal::Initialize(void)
{
    m_Font=wxFont::New(wxSize(0,12),wxFONTFAMILY_SWISS);
}

TGlobal::TGlobal(void)
{
    m_Font=NULL;
}

TGlobal::~TGlobal(void)
{
    if(m_Font)
    {
        delete m_Font;
    }
}

wxString FormatFrequency(int64_t Frequency)
{
 char s[64];
 const char *units;
 double f;
 int i;

    f=Frequency;

    if(fabs(f)<1000)
    {
        sprintf(s,"%.0f Hz",f);
    }
    else
    {
        f=Frequency;

        f/=1000;

        if(fabs(f)<1000)
        {
            i=sprintf(s,"%.3f",f);
            units="kHz";
        }
        else
        {
            f/=1000;

            if(fabs(f)<1000)
            {
                i=sprintf(s,"%.6f",f);
                units="MHz";
            }
            else
            {
                i=sprintf(s,"%.9f",f/1000);
                units="GHz";
            }
        }

        //remove triling zeros
        while(--i>=0)
        {
            if(s[i]=='.')
            {
                s[i]='\0';
                break;
            }

            if(s[i]!='0')
            {
                i++;
                break;
            }
        }

        s[i]=' ';//space between value and units
        strcpy(s+i+1,units);
    }

    return wxString(s,wxConvLocal);
}
