/*****************************************************************************/
/*                      WiNRADiO G65DDC EXCALIBUR SIGMA                      */
/*                          Coherent mode SDK DEMO                           */
/*                        (c) Copyright RADIXON 2023                         */
/*****************************************************************************/

#include "u_mainwindow.h"
#include "u_devicesetselector.h"
#include "u_defs.h"
#include "u_global.h"
#include <dlfcn.h>


class TApp: public wxApp
{
public:
    bool OnInit(void);
};

G65DDC_CREATE_INSTANCE CreateInstance;

bool TApp::OnInit(void)
{
 TMainWindow *MainWindow;
 ICohG65DDCDeviceSet *DeviceSet;
 void *API;

    API=dlopen("libg65ddcapi.so",RTLD_LAZY);

    if(API==NULL)
    {
        wxMessageBox(wxT("Failed to load libg65ddcapi.so!"),APP_TITLE_WX,wxICON_ERROR);
        return false;
    }

    CreateInstance=(G65DDC_CREATE_INSTANCE)dlsym(API,"CreateInstance");

    if(CreateInstance==NULL)
    {
        wxMessageBox(wxT("Failed to load valid libg65ddcapi.so!"),APP_TITLE_WX,wxICON_ERROR);
        dlclose(API);
        return false;
    }


    Global.Initialize();

    DeviceSet=TDeviceSetSelector::SelectDeviceSet();

    if(DeviceSet==NULL)
    {
        return false;
    }

    MainWindow=new TMainWindow(DeviceSet);

    MainWindow->Show(true);

    return true;
}

IMPLEMENT_APP(TApp)
